--[[
Frame structure:
1 	pionFrame
2 	pionFrameSpell
	2.1	pionSpell
	2.2	pionManaUsed
--]]
--[[
pionParseGained
	GainedName
	GainedSpell	
	GainedBuff

pionParseRemoved
	RemovedTarget
	RemovedName
	RemovedSpell
	RemovedBuff
--]]

piondefault = {
	["name"]			="PioN",
	["author"]			="Mahiro/Grognaz - Aegwynn(EU)",
	["version"]			=12007,
	["ManaSaved"]		=0,
	["ManaDiff"]		=0,	
	["ManaDiffSaved"]	=0,
	["fadeOut"]			=2,
	["fadeIn"]			=2,
	["debug"]			=0,
	["ss"]				=0,
}

function pionFrameOnLoad()
	
	SLASH_PION1 = "/pion"
	SlashCmdList["PION"] = pionCommand

	this:RegisterEvent("ADDON_LOADED")
	this:RegisterEvent("PLAYER_TARGET_CHANGED")	
	this:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	this:RegisterEvent("SPELL_AURA_APPLIED");
	this:RegisterEvent("SPELL_AURA_REMOVED");
	this:RegisterEvent("SPELL_AURA_DISPELLED");
	this:RegisterEvent("SPELL_AURA_STOLEN");
	
	--this:RegisterEvent("UNIT_AURA")

end

function pionLoadOnEvent()
	if (event=="ADDON_LOADED") and (arg1=="PioN") then
		if ((pionoptions==nil) 
		or (pionoptions.debuff==nil))
		or (piondefault.version~=12007)
		then		
			
			pionoptions={
				["pionFrame_X"]		= 0,
				["pionFrame_Y"]		= 0,
				["font"]			= "comicbd.ttf",
				["fontsize"]		= 10,
				["fontflags"]		= "OUTLINE",
				["standby"]			= false,
				["debuff"]			= true,
			}
			
			pionFrame:ClearAllPoints()
			pionFrame:SetPoint("CENTER", nil)
			pionoptions.pionFrame_Y = pionFrame:GetBottom()
			pionoptions.pionFrame_X = pionFrame:GetLeft()
			
			pionFrame:SetMovable(true)
			pionFrameSpell:EnableMouse(true)
			pionFrame:EnableMouse(true)
			
			pionFontFlagSlider:EnableMouse(true)
			pionFontSizeSlider:EnableMouse(true)
			pionFontSlider:EnableMouse(true)
			
			pionFontSizeSlider:SetMinMaxValues(6, 20)
			pionFontSizeSlider:SetOrientation("VERTICAL")
			pionFontSizeSlider:SetValue(pionoptions.fontsize)
			pionFontSizeSlider:SetValueStep(1)
			
		---[[
			--set values for fontsize and flags
			pionFontFlagSlider:SetMinMaxValues(1, 6)
			pionFontFlagSlider:SetOrientation("VERTICAL")
			pionFontFlagSlider:SetValue(2)
			pionFontFlagSlider:SetValueStep(1)
		--]]
						
			UIFrameFadeIn(pionFrame, piondefault.fadeIn, 0, 1)
			pionSpell:SetText(piondefault.name ..":")
			UIFrameFadeIn(pionSpell, piondefault.fadeIn, 0, 1)
			pionManaUsed:SetText("piondefault")
			UIFrameFadeIn(pionManaUsed, piondefault.fadeIn, 0, 1)
			
			pionDebuff:SetText("Debuff:")
			UIFrameFadeOut(pionDebuff, 5, 1, 0)
			if (pionoptions.debuff==true) then
				pionDebuffTime:SetText("Active")
			else
				pionDebuffTime:SetText("Inactive")
			end
			UIFrameFadeOut(pionDebuffTime, 5, 1, 0)
			
		else
			
			pionFrame:ClearAllPoints()
			pionFrame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", pionoptions.pionFrame_X, pionoptions.pionFrame_Y)
			
			pionoptions.pionFrame_X = pionFrame:GetLeft()
			pionoptions.pionFrame_Y = pionFrame:GetBottom()
			
			pionSpell:SetText(piondefault.name .." "  ..piondefault.version ..":")
			UIFrameFadeOut(pionSpell, 5, 1, 0)
			pionManaUsed:SetText("Loaded")
			UIFrameFadeOut(pionManaUsed, 5, 1, 0)
			
			pionDebuff:SetText("Debuff:")
			UIFrameFadeOut(pionDebuff, 5, 1, 0)
			if (pionoptions.debuff==true) then
				pionDebuffTime:SetText("Active")
			else
				pionDebuffTime:SetText("Inactive")
			end
			UIFrameFadeOut(pionDebuffTime, 5, 1, 0)
			
			
			pionFrameSpell:EnableMouse(false)
			pionFrame:EnableMouse(false)	
		--end
		end
			pionSpell:SetTextColor(1,1,1,1)
			pionSpell:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionManaUsed:SetTextColor(1,1,0,1)
			pionManaUsed:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			
			pionDebuff:SetTextColor(1,0,0,1)
			pionDebuff:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionDebuffTime:SetTextColor(1,1,0,1)
			pionDebuffTime:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
	
		if pionFrame:IsMovable() then 
			pionFrame:Show()
		else
			pionFrame:Hide()
		end
	end
end

local pionTargetName

function pionCheckOnEvent()
	if (event=="PLAYER_TARGET_CHANGED") then 
		--here we set the targetname on target change (this should fix our problem with arg7 on target change
		if (UnitExists("target")) then
			pionTargetName = UnitName("target")
			if (piondefault.debug==1) then
				DEFAULT_CHAT_FRAME:AddMessage(pionTargetName)
			end
		else
			pionTargetName = nil
			if (piondefault.debug==1) then
				DEFAULT_CHAT_FRAME:AddMessage("nil")
			end
		end
		
		Mana=0
		piondefault.ManaSaved=0
		piondefault.ManaDiff=0
		GainedBuff=0
		piondefault.ManaDiffSaved=0
		
		piondefault.ss=0
		
		if (piondefault.debug==1) then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- Mana - |cFF00FF00" ..Mana)
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- ManaSaved - |cFF00FF00" ..piondefault.ManaSaved)
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- ManaDiff - |cFF00FF00" ..piondefault.ManaDiff)
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- GainedBuff - |cFF00FF00" ..GainedBuff)
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- ManaDiffSaved - |cFF00FF00" ..piondefault.ManaDiffSaved)
		end
		--if (GainedBuff~=0) then
			--target changed
			--[[
			pionManaUsed:SetTextColor(1,1,0,1)
			pionSpell:SetText("Target:")
			UIFrameFadeOut(pionSpell, piondefault.fadeOut, 1, 0)
			pionManaUsed:SetText("Changed")
			UIFrameFadeOut(pionManaUsed, piondefault.fadeOut, 1, 0)
			--]]
			pionManaUsed:SetTextColor(1,1,0,1)
			pionSpell:SetText("")
			pionSpell:SetAlpha(0)
			pionManaUsed:SetText("")
			pionManaUsed:SetAlpha(0)
			
			--if (pionoptions.debuff==true) then
			pionDebuff:SetText("")
			pionDebuff:SetAlpha(0)
			pionDebuffTime:SetText("")
			pionDebuffTime:SetAlpha(0)
			--end
			
		--add debuff fade if not faded
		
		
		--else
			--[[
			if (GainedBuff==0) then
			
			end
			--]]
		--end
	end
	
	if (event=="UNIT_AURA") then
		
		--pionDebuffs();
	
	end
end

function pionCommand(cmd)
	if (cmd=="") then
		DEFAULT_CHAT_FRAME:AddMessage("/pion reset")
		DEFAULT_CHAT_FRAME:AddMessage("/pion status")
		DEFAULT_CHAT_FRAME:AddMessage("/pion standby")
		DEFAULT_CHAT_FRAME:AddMessage("/pion test")
		DEFAULT_CHAT_FRAME:AddMessage("/pion debuff (activate/deactivate target debuff warning")
		DEFAULT_CHAT_FRAME:AddMessage("/pion lock  (lock/unlock frame)")
	end
	
	if (cmd=="debuff") then
		if (pionoptions.debuff==false) then
			pionoptions.debuff=true
			
			pionDebuff:SetText("Debuff:")
			UIFrameFadeOut(pionDebuff, piondefault.fadeOut, 1, 0)
			pionDebuffTime:SetText("Enabled")
			UIFrameFadeOut(pionDebuffTime, piondefault.fadeOut, 1, 0)
		
		else pionoptions.debuff=false
			pionDebuff:SetText("Debuff:")
			UIFrameFadeOut(pionDebuff, piondefault.fadeOut, 1, 0)
			pionDebuffTime:SetText("Disabled")
			UIFrameFadeOut(pionDebuffTime, piondefault.fadeOut, 1, 0)
		end
	end
		
		
	if (cmd=="debug") then
		if (piondefault.debug==0) then
			piondefault.debug=1
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- Debug - |cFF00FF00" ..piondefault.debug)
		else piondefault.debug=0
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- Debug - |cFF00FF00" ..piondefault.debug)
		end
	end
	
	if (cmd=="reset") then
		pionoptions.pionFrame_X=0
		pionoptions.pionFrame_Y=0
		pionoptions.fontsize=10
		pionSpell:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
		pionManaUsed:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
		
		pionFrame:ClearAllPoints()
		pionFrame:SetPoint("CENTER", UIParent, "CENTER", pionoptions.pionFrame_X, pionoptions.pionFrame_Y)
			
		pionSpell:SetText(piondefault.name ..":")
		UIFrameFadeOut(pionSpell, piondefault.fadeOut, 1, 0)
		pionManaUsed:SetText("piondefault")
		UIFrameFadeOut(pionManaUsed, piondefault.fadeOut, 1, 0)
	end
	
	if (cmd=="status") then
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- Version - |cFF00FF00" ..piondefault.version)
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- Author - |cFF00FF00" ..piondefault.author)
		if (pionoptions.standby==true) then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- Addon - |cFFFF0000Disabled")		
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- Addon - |cFF00FF00Enabled")
		end
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- Font - |cFF00FF00" ..pionoptions.font)
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- Fontsize - |cFF00FF00" ..pionoptions.fontsize)
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- Debug - |cFF00FF00" ..piondefault.debug)
	end
	
	if (cmd=="standby") then
		if (pionoptions.standby==true) then
			pionSpell:SetText(piondefault.name ..":")
			UIFrameFadeOut(pionSpell, piondefault.fadeOut, 1, 0)
			pionManaUsed:SetText("Enabled")
			UIFrameFadeOut(pionManaUsed, piondefault.fadeOut, 1, 0)
			
			this:RegisterEvent("ADDON_LOADED")
			this:RegisterEvent("PLAYER_TARGET_CHANGED")
			--this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_BUFFS")
			--this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS")
			--this:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_OTHER")
			pionoptions.standby=false
		elseif (pionoptions.standby==false) then
			pionSpell:SetText(piondefault.name ..":")
			UIFrameFadeOut(pionSpell, piondefault.fadeOut, 1, 0)
			pionManaUsed:SetText("Disabled")
			UIFrameFadeOut(pionManaUsed, piondefault.fadeOut, 1, 0)
			
			this:UnregisterEvent("ADDON_LOADED")
			this:UnregisterEvent("PLAYER_TARGET_CHANGED")
			--this:UnregisterEvent("CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_BUFFS")
			--this:UnregisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS")
			--this:UnregisterEvent("CHAT_MSG_SPELL_AURA_GONE_OTHER")
			pionoptions.standby=true
		end
	end
	
	if (cmd=="test") then
		pionSpell:SetText(piondefault.name ..":")
		UIFrameFadeOut(pionSpell, 5, 1, 0)
		pionManaUsed:SetText("Test")
		UIFrameFadeOut(pionManaUsed, 5, 1, 0)
	end
	
	if (cmd=="lock") then
		if pionFrame:IsMovable() then 
			pionoptions.pionFrame_Y = pionFrame:GetBottom()
			pionoptions.pionFrame_X = pionFrame:GetLeft()
			pionFrame:ClearAllPoints()
			pionFrame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", pionoptions.pionFrame_X, pionoptions.pionFrame_Y)
			
			pionFrame:SetMovable(false)
			pionFrameSpell:EnableMouse(false)
			pionFrame:EnableMouse(false)
			
			pionFontFlagSlider:EnableMouse(false)
			pionFontSizeSlider:EnableMouse(false)
			pionFontSlider:EnableMouse(false)
			
			UIFrameFadeOut(pionFrame, piondefault.fadeOut, 1, 0)
			pionSpell:SetText(piondefault.name ..":")
			UIFrameFadeOut(pionSpell, piondefault.fadeOut, 1, 0)
			pionManaUsed:SetText("Locked")
			UIFrameFadeOut(pionManaUsed, piondefault.fadeOut, 1, 0)
			
			
			pionDebuff:SetText("Debuff:")
			UIFrameFadeOut(pionDebuff, piondefault.fadeOut, 1, 0)
			if (pionoptions.debuff==true) then
				pionDebuffTime:SetText("Active")
			else
				pionDebuffTime:SetText("Inactive")
			end
			UIFrameFadeOut(pionDebuffTime, piondefault.fadeOut, 1, 0)
			
		else
		if not pionFrame:IsMovable() then
			pionoptions.pionFrame_Y = pionFrame:GetBottom()
			pionoptions.pionFrame_X = pionFrame:GetLeft()
			pionFrame:GetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", pionoptions.pionFrame_X, pionoptions.pionFrame_Y)
			
			pionFrame:SetMovable(true)
			pionFrameSpell:EnableMouse(true)
			pionFrame:EnableMouse(true)

			pionFontFlagSlider:EnableMouse(true)
			pionFontSizeSlider:EnableMouse(true)
			pionFontSlider:EnableMouse(true)
			
			pionFontSizeSlider:SetMinMaxValues(6, 20)
			pionFontSizeSlider:SetOrientation("VERTICAL")
			pionFontSizeSlider:SetValue(pionoptions.fontsize)
			pionFontSizeSlider:SetValueStep(1)
			
			pionFontFlagSlider:SetMinMaxValues(1, 6)
			pionFontFlagSlider:SetOrientation("VERTICAL")
			if (pionoptions.fontflags==nil) then 
				pionFontFlagSlider:SetValue(1)
			elseif (pionoptions.fontflags=="OUTLINE") then 
				pionFontFlagSlider:SetValue(2)
			elseif (pionoptions.fontflags=="THICKOUTLINE") then 
				pionFontFlagSlider:SetValue(3)
			elseif (pionoptions.fontflags=="MONOCHROME") then 
				pionFontFlagSlider:SetValue(4)
			elseif (pionoptions.fontflags=="OUTLINE, MONOCHROME") then 
				pionFontFlagSlider:SetValue(5)
			elseif (pionoptions.fontflags=="THICKOUTLINE, MONOCHROME") then 
				pionFontFlagSlider:SetValue(6)
			end
			pionFontFlagSlider:SetValueStep(1)
						
			UIFrameFadeIn(pionFrame, piondefault.fadeIn, 0, 1)
			pionSpell:SetText(piondefault.name ..":")
			UIFrameFadeIn(pionSpell, piondefault.fadeIn, 0, 1)
			pionManaUsed:SetText("Unlocked")
			UIFrameFadeIn(pionManaUsed, piondefault.fadeIn, 0, 1)
			
			pionDebuff:SetText("Debuff:")
			UIFrameFadeIn(pionDebuff, piondefault.fadeIn, 0, 1)
			if (pionoptions.debuff==true) then
				pionDebuffTime:SetText("Active")
			else
				pionDebuffTime:SetText("Inactive")
			end
			UIFrameFadeIn(pionDebuffTime, piondefault.fadeIn, 0, 1)
		end
		end
	end	
end

function pionManaUpdate()
local Mana = UnitMana("target")
	if (UnitPowerType("target")==0)
	--[[
	has not fixed enrage display, the problem is the reset of the used mana.
	
	--]]
	and Mana>100 then
	
		if (pionoptions~=nil) and (pionoptions.standby==false) then
			--value check				
			if(piondefault.ManaSaved~=Mana) then
				--set mana diff value
				piondefault.ManaDiff = (piondefault.ManaSaved - Mana)
				if (piondefault.debug==1) then
					DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- ManaDiff - |cFF00FF00" ..piondefault.ManaDiff)
				end
				--set new mana value
				piondefault.ManaSaved = Mana
				if (piondefault.debug==1) then
					DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- ManaSaved - |cFF00FF00" ..piondefault.ManaSaved)
				end
			end
		end
	end

	--mana diff output
	if (GainedBuff~=0) 
	--
	and (piondefault.ManaDiffSaved==0) then
		piondefault.ManaDiffSaved = piondefault.ManaDiff
		if (piondefault.debug==1) then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- ManaDiffSaved - |cFF00FF00" ..piondefault.ManaDiffSaved)
		end
		if (piondefault.ManaDiffSaved>0) then
			pionManaUsed:SetText(piondefault.ManaDiffSaved)
			if (piondefault.debug==1) then
				DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- ManaDiffSaved - |cFF00FF00" ..piondefault.ManaDiffSaved)
			end
			UIFrameFadeIn(pionManaUsed,0,1,1)
			-- insert class costs
			pionCost();
			
		else 
			if (piondefault.debug==1) then
				--DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- cost<=0")
			end
		end
	end
end

function pionCost()

	local playerClass, englishClass = UnitClass("player")
	local base, stat, posBuff, negBuff = UnitStat("player", 4)
	local mpmax = UnitManaMax("player")

	if (englishClass=="MAGE") then
		--mage talent check
		local _, _, _, _, currentRank, _, _, _ = GetTalentInfo(1, 15)
		local div = (1.0 + currentRank/100)
		local managain = ((base*div*15)-280)
		--spellsteal	
		pioncost = 0.29	
		spellcost = ((mpmax-managain)*pioncost)
	elseif (englishClass=="SHAMAN") then
		--shaman talent check
		local _, _, _, _, currentRank, _, _, _ = GetTalentInfo(2, 2)
		local div = (1.0 + currentRank/100)
		local AncestralKnowledge = string.format("%.0f", (mpmax/div)) --correct format it
		local managain = ((base*15)-280)
		--purge
		pioncost= 0.08
		spellcost = ((mpmax-managain)*pioncost)
	else
		--other classes
		spellcost=nil
	end
	
	pionColor(spellcost);
	
	if (piondefault.debug==1) then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- Spellcost - |cFF00FF00" ..spellcost)
	end
end

function pionColor(spellcost)
	if (spellcost~=nil) then
		if(piondefault.ManaDiffSaved>spellcost) then 
			pionManaUsed:SetTextColor(0,1,0,1)
		elseif (piondefault.ManaDiffSaved==spellcost) then
			pionManaUsed:SetTextColor(1,1,0,1)
		elseif (piondefault.ManaDiffSaved<=spellcost) then
			pionManaUsed:SetTextColor(1,0,0,1)
		end
	else
		--your classe has no dispell costs (spellcost)
		pionManaUsed:SetTextColor(1,1,0,1)
	end
end

--[[
COMBAT_LOG_EVENT
arg2=SPELL_AURA_APPLIED
arg7 = caster name
arg10 = spellname


		((event == "SPELL_AURA_REMOVED") or 
		(event == "SPELL_AURA_DISPELLED") or 
		(event == "SPELL_AURA_STOLEN")) then 
SPELL spellId spellName spellSchool  


	 if (bit.band(targetflags, COMBATLOG_OBJECT_TARGET)~=0) then 
	--target of event is your target
	 end
	 PLAYER_TARGET CHANGED: targetGUID = UnitGUID("target");
	--]] 

function pionParseGained()
	local what = arg2 or 0;
	local spelln = arg10 or 0;
	local GainedName = arg7 or 0;
	local buff = arg12 or 0;
	
	if (pionoptions~=nil) and (pionoptions.standby==false) then
		if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
			if (what == "SPELL_AURA_APPLIED" ) then 
				if (GainedName == pionTargetName and buff=="BUFF") then  
					GainedBuff=spelln
					pionSpell:SetText("Gained: " ..GainedBuff)
					UIFrameFadeIn(pionSpell,0,1,1)
					if (piondefault.debug==1) then
						DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- GainedName - |cFF00FF00" ..GainedName)
						DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- GainedBuff - |cFF00FF00" ..GainedBuff)
					end
				end
			end
		end
	end
end
	 
function pionParseRemoved()

	local what = arg2 or 0;
	local spelln = arg10 or 0;
	local RemovedTarget = arg7 or 0;
	local buff = arg12 or 0;
	
	if (pionoptions~=nil) and (pionoptions.standby==false) then
	
	if (event == "COMBAT_LOG_EVENT_UNFILTERED") then
		if (what == "SPELL_AURA_REMOVED" 
		or what == "SPELL_AURA_DISPELLED" 
		or what == "SPELL_AURA_STOLEN") then 
				if (RemovedTarget == pionTargetName and buff=="BUFF") then 
					--if (RemovedBuff~=nil) and (GainedBuff==arg1) then	
						Mana=0
						piondefault.ManaSaved=0
						piondefault.ManaDiff=0
						GainedBuff=0
						piondefault.ManaDiffSaved=0
						
						pionSpell:SetText("Removed: " ..spelln)
						
						pionManaUsed:SetTextColor(1,1,0,1)
						UIFrameFadeOut(pionSpell, piondefault.fadeOut, 1, 0)
					--disable this output for release!!	
						pionManaUsed:SetText(piondefault.ManaDiffSaved)
						UIFrameFadeOut(pionManaUsed, piondefault.fadeOut, 1, 0)
						if (piondefault.debug==1) then
							DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- Mana - |cFF00FF00" ..Mana)
							DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- ManaSaved - |cFF00FF00" ..piondefault.ManaSaved)
							DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- ManaDiff - |cFF00FF00" ..piondefault.ManaDiff)
							DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- GainedBuff - |cFF00FF00" ..spelln)
							DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00" ..piondefault.name .." |r- ManaDiffSaved - |cFF00FF00" ..piondefault.ManaDiffSaved)
						end
					--end
				end
			end
		end
	end
end

function pionOnMouseUp()
	if (pionFrame.isMoving) then
		pionFrame:StopMovingOrSizing()
		pionFrame.isMoving = false
		pionoptions.pionFrame_Y = pionFrame:GetBottom()
		pionoptions.pionFrame_X = pionFrame:GetLeft()
		pionFrame:ClearAllPoints()
		pionFrame:SetPoint("BOTTOMLEFT", UIParent, "BOTTOMLEFT", pionoptions.pionFrame_X, pionoptions.pionFrame_Y)
	end
end

function pionOnMouseDown()
	if (pionFrame:IsMovable()) then	
		if ((not pionFrame.isLocked) or (pionFrame.isLocked==0) and (arg1=="LeftButton")) then
			pionFrame:StartMoving()
			pionFrame.isMoving = true
		end
	end
end

function pionFontSize()
	pionFontSizeSlider:SetMinMaxValues(6, 20)
	pionFontSizeSlider:SetOrientation("VERTICAL")
	pionFontSizeSlider:SetValueStep(1)

	if pionFontSizeSlider:GetValue() then 
		pionFontSizeSlider:SetValue(pionFontSizeSlider:GetValue())
		pionoptions.fontsize=pionFontSizeSlider:GetValue()
		UIFrameFadeIn(pionSpell, 0, 1, 1)
		UIFrameFadeIn(pionManaUsed, 0, 1, 1)
		
		UIFrameFadeIn(pionDebuff, 0, 1, 1)
		UIFrameFadeIn(pionDebuffTime, 0, 1, 1)
		
		pionSpell:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
		pionManaUsed:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
		
		pionDebuff:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
		pionDebuffTime:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
		
		pionManaUsed:SetText("Fontsize " .."(" ..pionoptions.fontsize ..")")
		
		--DEFAULT_CHAT_FRAME:AddMessage(pionoptions.fontsize)

	end
end

function pionFont()
	pionFontSlider:SetMinMaxValues(1, 2)
	pionFontSlider:SetOrientation("VERTICAL")
	pionFontSlider:SetValueStep(1)
	
	
end

function pionFontFlag()		--OUTLINE, THICKOUTLINE and/or MONOCHROME

	pionFontFlagSlider:SetMinMaxValues(1, 6)
	pionFontFlagSlider:SetOrientation("VERTICAL")
	pionFontFlagSlider:SetValueStep(1)
	
	if pionFontFlagSlider:GetValue() then 
		pionFontFlagSlider:SetValue(pionFontFlagSlider:GetValue())
		
		if (pionFontFlagSlider:GetValue()==1) then
			pionoptions.fontflags=nil
			
			UIFrameFadeIn(pionSpell, 0, 1, 1)
			UIFrameFadeIn(pionManaUsed, 0, 1, 1)
			UIFrameFadeIn(pionDebuff, 0, 1, 1)
			UIFrameFadeIn(pionDebuffTime, 0, 1, 1)
			
			pionSpell:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionManaUsed:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionDebuff:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionDebuffTime:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			
			pionManaUsed:SetText("Fontflag (none)")
		
		elseif (pionFontFlagSlider:GetValue()==2) then
			pionoptions.fontflags="OUTLINE"
			
			UIFrameFadeIn(pionSpell, 0, 1, 1)
			UIFrameFadeIn(pionManaUsed, 0, 1, 1)
			UIFrameFadeIn(pionDebuff, 0, 1, 1)
			UIFrameFadeIn(pionDebuffTime, 0, 1, 1)
		
			pionSpell:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionManaUsed:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionDebuff:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionDebuffTime:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			
			pionManaUsed:SetText("Fontflag " .."(" ..pionoptions.fontflags ..")")
		
		elseif (pionFontFlagSlider:GetValue()==3) then
			pionoptions.fontflags="THICKOUTLINE"
			
			UIFrameFadeIn(pionSpell, 0, 1, 1)
			UIFrameFadeIn(pionManaUsed, 0, 1, 1)
			UIFrameFadeIn(pionDebuff, 0, 1, 1)
			UIFrameFadeIn(pionDebuffTime, 0, 1, 1)
			
			pionSpell:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionManaUsed:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionDebuff:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionDebuffTime:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			
			pionManaUsed:SetText("Fontflag " .."(" ..pionoptions.fontflags ..")")
		
		elseif (pionFontFlagSlider:GetValue()==4) then
			pionoptions.fontflags="MONOCHROME"
			
			UIFrameFadeIn(pionSpell, 0, 1, 1)
			UIFrameFadeIn(pionManaUsed, 0, 1, 1)
			UIFrameFadeIn(pionDebuff, 0, 1, 1)
			UIFrameFadeIn(pionDebuffTime, 0, 1, 1)
			
			pionSpell:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionManaUsed:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionDebuff:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionDebuffTime:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			
			pionManaUsed:SetText("Fontflag " .."(" ..pionoptions.fontflags ..")")
		
		elseif (pionFontFlagSlider:GetValue()==5) then
			pionoptions.fontflags="OUTLINE, MONOCHROME"
			
			UIFrameFadeIn(pionSpell, 0, 1, 1)
			UIFrameFadeIn(pionManaUsed, 0, 1, 1)
			UIFrameFadeIn(pionDebuff, 0, 1, 1)
			UIFrameFadeIn(pionDebuffTime, 0, 1, 1)
			
			pionSpell:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionManaUsed:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionDebuff:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionDebuffTime:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			
			pionManaUsed:SetText("Fontflag " .."(" ..pionoptions.fontflags ..")")
		
		elseif (pionFontFlagSlider:GetValue()==6) then
			pionoptions.fontflags="THICKOUTLINE, MONOCHROME"
			
			UIFrameFadeIn(pionSpell, 0, 1, 1)
			UIFrameFadeIn(pionManaUsed, 0, 1, 1)
			UIFrameFadeIn(pionDebuff, 0, 1, 1)
			UIFrameFadeIn(pionDebuffTime, 0, 1, 1)
			
			pionSpell:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionManaUsed:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionDebuff:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			pionDebuffTime:SetFont("Interface\\AddOns\\PioN\\fonts\\" ..pionoptions.font, pionoptions.fontsize, pionoptions.fontflags)
			
			pionManaUsed:SetText("Fontflag " .."(" ..pionoptions.fontflags ..")")
		end
	end	
end

function pionDebuffs()
	
	if (UnitExists("target") and (pionoptions.debuff==true)) then
		local name, count, timeLeft
		for i=1,40 do name, _, _, count, _, _, timeLeft  =  UnitDebuff("target", i)
			if (name==PION_STORMSTRIKE) then
				piondefault.ss=1
			break
			else 
				piondefault.ss=0
			end
		end

		if (piondefault.ss==1) then
			--DEFAULT_CHAT_FRAME:AddMessage(name)		
			--DEFAULT_CHAT_FRAME:AddMessage(timeLeft)
			pionDebuff:SetText(name)
			pionDebuff:SetAlpha(1)
			if (timeLeft~=nil) then
				pionDebuffTime:SetText("x "..count.." | "..string.format("%.1f", timeLeft))
			else 
				pionDebuffTime:SetText("x "..count)
			end
			pionDebuffTime:SetAlpha(1)
		else
			--DEFAULT_CHAT_FRAME:AddMessage(name)		
			--DEFAULT_CHAT_FRAME:AddMessage("stop")
			pionDebuff:SetText("")
			pionDebuff:SetAlpha(0)
			pionDebuffTime:SetText(count)
			pionDebuffTime:SetAlpha(0)
		end	
	end
end
